import { CodeLens, CompletionItem, Position, Range } from "vscode-languageserver-types";
import { SwfServiceCatalogService } from "@kie-tools/serverless-workflow-service-catalog/dist/api";
export interface SwfLanguageServiceChannelApi {
    kogitoSwfLanguageService__getCompletionItems(args: {
        content: string;
        uri: string;
        cursorPosition: Position;
        cursorWordRange: Range;
    }): Promise<CompletionItem[]>;
    kogitoSwfLanguageService__getCodeLenses(args: {
        uri: string;
        content: string;
    }): Promise<CodeLens[]>;
}
export declare type SwfLanguageServiceCommandTypes = "swf.ls.commands.ImportFunctionFromCompletionItem" | "swf.ls.commands.OpenFunctionsWidget" | "swf.ls.commands.OpenStatesWidget" | "swf.ls.commands.OpenCompletionItems" | "swf.ls.commands.OpenServiceRegistriesConfig" | "swf.ls.commands.LogInServiceRegistries" | "swf.ls.commands.RefreshServiceRegistries";
export declare type SwfLanguageServiceCommandArgs = {
    "swf.ls.commands.ImportFunctionFromCompletionItem": {
        containingService: SwfServiceCatalogService;
        documentUri: string;
    };
    "swf.ls.commands.OpenFunctionsWidget": {
        position: Position;
    };
    "swf.ls.commands.OpenStatesWidget": {
        position: Position;
    };
    "swf.ls.commands.OpenCompletionItems": {
        newCursorPosition: Position;
    };
    "swf.ls.commands.OpenServiceRegistriesConfig": {};
    "swf.ls.commands.LogInServiceRegistries": {};
    "swf.ls.commands.RefreshServiceRegistries": {};
};
export declare type SwfLanguageServiceCommandIds = Record<SwfLanguageServiceCommandTypes, string>;
export declare type SwfLanguageServiceCommandHandlers = {
    [K in SwfLanguageServiceCommandTypes]: (args: SwfLanguageServiceCommandArgs[K]) => any;
};
export interface SwfLanguageServiceCommandExecution<T extends SwfLanguageServiceCommandTypes> {
    name: T;
    args: SwfLanguageServiceCommandArgs[T];
}
//# sourceMappingURL=SwfLanguageServiceChannelApi.d.ts.map