export declare type StateBlockOffset = {
    start: number;
    end: number;
};
export declare type StateOffsets = {
    stateNameOffset: number;
    offset: StateBlockOffset;
};
export declare type StatesOffsets = {
    [key: string]: StateOffsets;
};
export declare type FullTextOffsets = {
    states: StatesOffsets;
};
export declare abstract class SwfOffsetsApi {
    protected astTransformQuery: string;
    documentUri: string;
    protected fullText: string;
    protected fullTextOffsets: FullTextOffsets | undefined;
    constructor(astTransformQuery: string, documentUri?: string);
    parseContent(fullText: string): SwfOffsetsApi;
    abstract getFullAST(): any;
    getAllOffsets(): FullTextOffsets;
    getStateNameOffset(stateName: string): number | undefined;
    getStateNameFromOffset(offset: number): string | null;
}
//# sourceMappingURL=SwfOffsetsApi.d.ts.map