import { TextDocument } from "vscode-languageserver-textdocument";
import { CodeLens, CompletionItem, CompletionItemKind, Diagnostic, Position, Range } from "vscode-languageserver-types";
import { SwfLanguageServiceArgs } from "./SwfLanguageService";
import { CodeCompletionStrategy, ShouldCompleteArgs, ShouldCreateCodelensArgs, SwfLsNode, TranslateArgs } from "./types";
export declare function hasNodeComma(content: string, cursorOffset: number): boolean;
export declare function isOffsetAtLastChild(content: string, cursorOffset: number): boolean;
export declare class SwfJsonLanguageService {
    private readonly ls;
    private readonly codeCompletionStrategy;
    constructor(args: Omit<SwfLanguageServiceArgs, "lang">);
    parseContent(content: string): SwfLsNode | undefined;
    getCompletionItems(args: {
        content: string;
        uri: string;
        cursorPosition: Position;
        cursorWordRange: Range;
    }): Promise<CompletionItem[]>;
    getCodeLenses(args: {
        content: string;
        uri: string;
    }): Promise<CodeLens[]>;
    getDiagnostics(args: {
        content: string;
        uriPath: string;
    }): Promise<Diagnostic[]>;
    private getSchemaDiagnostics;
    dispose(): void;
}
export declare class JsonCodeCompletionStrategy implements CodeCompletionStrategy {
    translate(args: TranslateArgs): string;
    formatLabel(label: string, completionItemKind: CompletionItemKind): string;
    getStartNodeValuePosition(document: TextDocument, node: SwfLsNode): Position | undefined;
    shouldComplete(args: ShouldCompleteArgs): boolean;
    shouldCreateCodelens(_args: ShouldCreateCodelensArgs): boolean;
}
//# sourceMappingURL=SwfJsonLanguageService.d.ts.map