"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.positions_equals = exports.getNodePath = exports.findNodeAtOffset = exports.findNodeAtLocation = exports.SwfLanguageService = void 0;
var api_1 = require("@kie-tools/serverless-workflow-service-catalog/dist/api");
var jsonc = require("jsonc-parser");
var path_1 = require("path");
var vscode_languageserver_textdocument_1 = require("vscode-languageserver-textdocument");
var findNodesAtLocation_1 = require("./findNodesAtLocation");
var refValidation_1 = require("./refValidation");
var SwfLanguageServiceCodeCompletion_1 = require("./SwfLanguageServiceCodeCompletion");
var SwfLanguageServiceCodeLenses_1 = require("./SwfLanguageServiceCodeLenses");
var SwfLanguageService = (function () {
    function SwfLanguageService(args) {
        this.args = args;
    }
    SwfLanguageService.prototype.getCompletionItems = function (args) {
        return __awaiter(this, void 0, void 0, function () {
            var doc, cursorOffset, currentNode, currentNodeRange, overwriteRange, swfCompletionItemServiceCatalogServices, _a, _b, _c, _d, matchedCompletions, result;
            var _this = this;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        doc = vscode_languageserver_textdocument_1.TextDocument.create(args.uri, this.args.lang.fileLanguage, 0, args.content);
                        cursorOffset = doc.offsetAt(args.cursorPosition);
                        if (!args.rootNode) {
                            return [2, args.content.trim().length
                                    ? []
                                    : SwfLanguageServiceCodeCompletion_1.SwfLanguageServiceCodeCompletion.getEmptyFileCodeCompletions(__assign(__assign({}, args), { cursorOffset: cursorOffset, document: doc }))];
                        }
                        currentNode = findNodeAtOffset(args.rootNode, cursorOffset, true);
                        if (!currentNode) {
                            return [2, []];
                        }
                        currentNodeRange = {
                            start: doc.positionAt(currentNode.offset),
                            end: doc.positionAt(currentNode.offset + currentNode.length),
                        };
                        overwriteRange = ["string", "number", "boolean", "null"].includes(currentNode === null || currentNode === void 0 ? void 0 : currentNode.type)
                            ? currentNodeRange
                            : args.cursorWordRange;
                        _b = (_a = Promise).all;
                        _c = [[]];
                        return [4, this.args.serviceCatalog.global.getServices()];
                    case 1:
                        _d = [__spreadArray.apply(void 0, _c.concat([__read.apply(void 0, [(_e.sent())]), false]))];
                        return [4, this.args.serviceCatalog.relative.getServices(doc)];
                    case 2: return [4, _b.apply(_a, [__spreadArray.apply(void 0, _d.concat([__read.apply(void 0, [(_e.sent())]), false])).map(function (service) { return __awaiter(_this, void 0, void 0, function () {
                                var _a;
                                var _b;
                                var _this = this;
                                return __generator(this, function (_c) {
                                    switch (_c.label) {
                                        case 0:
                                            _a = [__assign({}, service)];
                                            _b = {};
                                            return [4, Promise.all(service.functions.map(function (func) { return __awaiter(_this, void 0, void 0, function () {
                                                    var _a;
                                                    var _b;
                                                    return __generator(this, function (_c) {
                                                        switch (_c.label) {
                                                            case 0:
                                                                _a = [__assign({}, func)];
                                                                _b = {};
                                                                return [4, this.getSwfCompletionItemServiceCatalogFunctionOperation(service, func, doc)];
                                                            case 1: return [2, (__assign.apply(void 0, _a.concat([(_b.operation = _c.sent(), _b)])))];
                                                        }
                                                    });
                                                }); }))];
                                        case 1: return [2, (__assign.apply(void 0, _a.concat([(_b.functions = _c.sent(), _b)])))];
                                    }
                                });
                            }); })])];
                    case 3:
                        swfCompletionItemServiceCatalogServices = _e.sent();
                        matchedCompletions = Array.from(completions.entries()).filter(function (_a) {
                            var _b = __read(_a, 2), path = _b[0], _ = _b[1];
                            return args.codeCompletionStrategy.shouldComplete({
                                content: args.content,
                                cursorOffset: cursorOffset,
                                cursorPosition: args.cursorPosition,
                                node: currentNode,
                                path: path,
                                root: args.rootNode,
                            });
                        });
                        return [4, Promise.all(matchedCompletions.map(function (_a) {
                                var _b = __read(_a, 2), _ = _b[0], completionItemsDelegate = _b[1];
                                return completionItemsDelegate({
                                    codeCompletionStrategy: args.codeCompletionStrategy,
                                    currentNode: currentNode,
                                    currentNodeRange: currentNodeRange,
                                    cursorOffset: cursorOffset,
                                    cursorPosition: args.cursorPosition,
                                    document: doc,
                                    langServiceConfig: _this.args.config,
                                    overwriteRange: overwriteRange,
                                    rootNode: args.rootNode,
                                    swfCompletionItemServiceCatalogServices: swfCompletionItemServiceCatalogServices,
                                });
                            }))];
                    case 4:
                        result = _e.sent();
                        return [2, Promise.resolve(result.flat())];
                }
            });
        });
    };
    SwfLanguageService.prototype.getDiagnostics = function (args) {
        return __awaiter(this, void 0, void 0, function () {
            var docVersion, textDocument, refValidationResults, schemaValidationResults, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!args.rootNode) {
                            return [2, []];
                        }
                        docVersion = Math.floor(Math.random() * 1000);
                        textDocument = vscode_languageserver_textdocument_1.TextDocument.create(args.uriPath, "serverless-workflow-".concat(this.args.lang.fileLanguage), docVersion, args.content);
                        refValidationResults = (0, refValidation_1.doRefValidation)({ textDocument: textDocument, rootNode: args.rootNode });
                        return [4, this.args.config.shouldIncludeJsonSchemaDiagnostics()];
                    case 1:
                        if (!(_b.sent())) return [3, 3];
                        return [4, args.getSchemaDiagnostics(textDocument, this.args.lang.fileMatch)];
                    case 2:
                        _a = _b.sent();
                        return [3, 4];
                    case 3:
                        _a = [];
                        _b.label = 4;
                    case 4:
                        schemaValidationResults = _a;
                        return [2, __spreadArray(__spreadArray([], __read(schemaValidationResults), false), __read(refValidationResults), false)];
                }
            });
        });
    };
    SwfLanguageService.prototype.getCodeLenses = function (args) {
        return __awaiter(this, void 0, void 0, function () {
            var document, displayRhhccIntegration, codeLensesFunctionsArgs;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!args.content.trim().length) {
                            return [2, SwfLanguageServiceCodeLenses_1.SwfLanguageServiceCodeLenses.createNewSWF()];
                        }
                        if (!args.rootNode) {
                            return [2, []];
                        }
                        document = vscode_languageserver_textdocument_1.TextDocument.create(args.uri, this.args.lang.fileLanguage, 0, args.content);
                        return [4, this.args.config.shouldDisplayServiceRegistriesIntegration()];
                    case 1:
                        displayRhhccIntegration = _a.sent();
                        codeLensesFunctionsArgs = {
                            config: this.args.config,
                            document: document,
                            content: args.content,
                            rootNode: args.rootNode,
                            codeCompletionStrategy: args.codeCompletionStrategy,
                        };
                        return [2, __spreadArray(__spreadArray(__spreadArray(__spreadArray(__spreadArray(__spreadArray([], __read((displayRhhccIntegration ? SwfLanguageServiceCodeLenses_1.SwfLanguageServiceCodeLenses.setupServiceRegistries(codeLensesFunctionsArgs) : [])), false), __read((displayRhhccIntegration ? SwfLanguageServiceCodeLenses_1.SwfLanguageServiceCodeLenses.logInServiceRegistries(codeLensesFunctionsArgs) : [])), false), __read((displayRhhccIntegration
                                ? SwfLanguageServiceCodeLenses_1.SwfLanguageServiceCodeLenses.refreshServiceRegistries(codeLensesFunctionsArgs)
                                : [])), false), __read(SwfLanguageServiceCodeLenses_1.SwfLanguageServiceCodeLenses.addFunction(codeLensesFunctionsArgs)), false), __read(SwfLanguageServiceCodeLenses_1.SwfLanguageServiceCodeLenses.addEvent(codeLensesFunctionsArgs)), false), __read(SwfLanguageServiceCodeLenses_1.SwfLanguageServiceCodeLenses.addState(codeLensesFunctionsArgs)), false)];
                }
            });
        });
    };
    SwfLanguageService.prototype.dispose = function () {
    };
    SwfLanguageService.prototype.getSwfCompletionItemServiceCatalogFunctionOperation = function (containingService, func, document) {
        return __awaiter(this, void 0, void 0, function () {
            var specsDirRelativePosixPath, serviceFileName, serviceFileRelativePosixPath, serviceFileName, serviceFileRelativePosixPath;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.args.config.getSpecsDirPosixPaths(document)];
                    case 1:
                        specsDirRelativePosixPath = (_a.sent()).specsDirRelativePosixPath;
                        if (!(func.source.type === api_1.SwfServiceCatalogFunctionSourceType.LOCAL_FS)) return [3, 2];
                        serviceFileName = path_1.posix.basename(func.source.serviceFileAbsolutePath);
                        serviceFileRelativePosixPath = path_1.posix.join(specsDirRelativePosixPath, serviceFileName);
                        return [2, "".concat(serviceFileRelativePosixPath, "#").concat(func.name)];
                    case 2: return [4, this.args.config.shouldReferenceServiceRegistryFunctionsWithUrls()];
                    case 3:
                        if (!((_a.sent()) &&
                            containingService.source.type === api_1.SwfServiceCatalogServiceSourceType.SERVICE_REGISTRY &&
                            func.source.type === api_1.SwfServiceCatalogFunctionSourceType.SERVICE_REGISTRY)) return [3, 4];
                        return [2, "".concat(containingService.source.url, "#").concat(func.name)];
                    case 4:
                        if (!(containingService.source.type === api_1.SwfServiceCatalogServiceSourceType.SERVICE_REGISTRY &&
                            func.source.type === api_1.SwfServiceCatalogFunctionSourceType.SERVICE_REGISTRY)) return [3, 6];
                        return [4, this.args.serviceCatalog.getServiceFileNameFromSwfServiceCatalogServiceId(containingService.source.registry, containingService.source.id)];
                    case 5:
                        serviceFileName = _a.sent();
                        serviceFileRelativePosixPath = path_1.posix.join(specsDirRelativePosixPath, serviceFileName);
                        return [2, "".concat(serviceFileRelativePosixPath, "#").concat(func.name)];
                    case 6: throw new Error("Unknown Service Catalog function source type");
                }
            });
        });
    };
    return SwfLanguageService;
}());
exports.SwfLanguageService = SwfLanguageService;
var completions = new Map([
    [["start"], SwfLanguageServiceCodeCompletion_1.SwfLanguageServiceCodeCompletion.getStartCompletions],
    [["functions", "*"], SwfLanguageServiceCodeCompletion_1.SwfLanguageServiceCodeCompletion.getFunctionCompletions],
    [["functions", "*", "operation"], SwfLanguageServiceCodeCompletion_1.SwfLanguageServiceCodeCompletion.getFunctionOperationCompletions],
    [["events", "*"], SwfLanguageServiceCodeCompletion_1.SwfLanguageServiceCodeCompletion.getEventsCompletions],
    [["states", "*"], SwfLanguageServiceCodeCompletion_1.SwfLanguageServiceCodeCompletion.getStatesCompletions],
    [["states", "*", "actions", "*", "functionRef"], SwfLanguageServiceCodeCompletion_1.SwfLanguageServiceCodeCompletion.getFunctionRefCompletions],
    [
        ["states", "*", "actions", "*", "functionRef", "refName"],
        SwfLanguageServiceCodeCompletion_1.SwfLanguageServiceCodeCompletion.getFunctionRefRefnameCompletions,
    ],
    [
        ["states", "*", "actions", "*", "functionRef", "arguments"],
        SwfLanguageServiceCodeCompletion_1.SwfLanguageServiceCodeCompletion.getFunctionRefArgumentsCompletions,
    ],
    [["states", "*", "onEvents", "*", "eventRefs", "*"], SwfLanguageServiceCodeCompletion_1.SwfLanguageServiceCodeCompletion.getEventRefsCompletions],
    [["states", "*", "transition"], SwfLanguageServiceCodeCompletion_1.SwfLanguageServiceCodeCompletion.getTransitionCompletions],
    [["states", "*", "dataConditions", "*", "transition"], SwfLanguageServiceCodeCompletion_1.SwfLanguageServiceCodeCompletion.getTransitionCompletions],
    [["states", "*", "defaultCondition", "transition"], SwfLanguageServiceCodeCompletion_1.SwfLanguageServiceCodeCompletion.getTransitionCompletions],
    [["states", "*", "eventConditions", "*", "transition"], SwfLanguageServiceCodeCompletion_1.SwfLanguageServiceCodeCompletion.getTransitionCompletions],
]);
function findNodeAtLocation(root, path) {
    return (0, findNodesAtLocation_1.findNodesAtLocation)({ root: root, path: path })[0];
}
exports.findNodeAtLocation = findNodeAtLocation;
function findNodeAtOffset(root, offset, includeRightBound) {
    return jsonc.findNodeAtOffset(root, offset, includeRightBound);
}
exports.findNodeAtOffset = findNodeAtOffset;
function getNodePath(node) {
    return jsonc.getNodePath(node);
}
exports.getNodePath = getNodePath;
var positions_equals = function (a, b) {
    return (a === null || a === void 0 ? void 0 : a.line) === (b === null || b === void 0 ? void 0 : b.line) && (a === null || a === void 0 ? void 0 : a.character) == (b === null || b === void 0 ? void 0 : b.character);
};
exports.positions_equals = positions_equals;
//# sourceMappingURL=SwfLanguageService.js.map