"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SwfLanguageServiceCodeCompletion = void 0;
var api_1 = require("@kie-tools/serverless-workflow-service-catalog/dist/api");
var vscode_languageserver_types_1 = require("vscode-languageserver-types");
var SwfLanguageService_1 = require("./SwfLanguageService");
var code_completions_1 = require("../assets/code-completions");
var swfModelQueries = require("./modelQueries");
var nodeUpUntilType_1 = require("./nodeUpUntilType");
var SwfLanguageService_2 = require("./SwfLanguageService");
function toCompletionItemLabel(namespace, resource, operation) {
    return "".concat(namespace, "\u00BB").concat(resource, "#").concat(operation);
}
function toCompletionItemLabelPrefix(swfServiceCatalogFunction, specsDirRelativePosixPath) {
    var _a;
    switch (swfServiceCatalogFunction.source.type) {
        case api_1.SwfServiceCatalogFunctionSourceType.LOCAL_FS:
            var fileName = (_a = swfServiceCatalogFunction.source.serviceFileAbsolutePath.split("/").pop()) !== null && _a !== void 0 ? _a : swfServiceCatalogFunction.source.serviceFileAbsolutePath;
            return toCompletionItemLabel(specsDirRelativePosixPath, fileName, swfServiceCatalogFunction.name);
        case api_1.SwfServiceCatalogFunctionSourceType.SERVICE_REGISTRY:
            return toCompletionItemLabel(swfServiceCatalogFunction.source.registry, swfServiceCatalogFunction.source.serviceId, swfServiceCatalogFunction.name);
        default:
            return "";
    }
}
function createCompletionItem(args) {
    return __assign({ kind: args.kind, label: args.label, sortText: "100_".concat(args.label), filterText: args.label, detail: args.detail, textEdit: {
            newText: args.codeCompletionStrategy.translate(__assign(__assign({}, args), { completionItemKind: args.kind })),
            range: args.overwriteRange,
        }, insertTextFormat: vscode_languageserver_types_1.InsertTextFormat.Snippet }, args.extraOptions);
}
function getStateNameCompletion(args) {
    return args.states.flatMap(function (state) {
        var kind = vscode_languageserver_types_1.CompletionItemKind.Value;
        var label = args.codeCompletionStrategy.formatLabel(state.name, kind);
        return [
            createCompletionItem(__assign(__assign({}, args), { completion: "".concat(state.name), kind: kind, label: label, detail: "\"".concat(state.name, "\"") })),
        ];
    });
}
exports.SwfLanguageServiceCodeCompletion = {
    getEmptyFileCodeCompletions: function (args) {
        var kind = vscode_languageserver_types_1.CompletionItemKind.Text;
        var label = "Create your first Serverless Workflow";
        return [
            {
                kind: kind,
                label: label,
                detail: "Start with a simple Serverless Workflow",
                sortText: "100_".concat(label),
                textEdit: {
                    newText: args.codeCompletionStrategy.translate(__assign(__assign({}, args), { completion: code_completions_1.workflowCompletion, completionItemKind: kind })),
                    range: vscode_languageserver_types_1.Range.create(args.cursorPosition, args.cursorPosition),
                },
                insertTextFormat: vscode_languageserver_types_1.InsertTextFormat.Snippet,
            },
        ];
    },
    getEventsCompletions: function (args) { return __awaiter(void 0, void 0, void 0, function () {
        var kind;
        return __generator(this, function (_a) {
            kind = vscode_languageserver_types_1.CompletionItemKind.Interface;
            return [2, Promise.resolve([
                    createCompletionItem(__assign(__assign({}, args), { completion: code_completions_1.eventCompletion, kind: kind, label: "New event", detail: "Add a new event" })),
                ])];
        });
    }); },
    getStatesCompletions: function (args) { return __awaiter(void 0, void 0, void 0, function () {
        var kind;
        return __generator(this, function (_a) {
            kind = vscode_languageserver_types_1.CompletionItemKind.Interface;
            return [2, Promise.resolve([
                    createCompletionItem(__assign(__assign({}, args), { completion: code_completions_1.operationStateCompletion, kind: kind, label: "New operation state", detail: "Add a new operation state" })),
                    createCompletionItem(__assign(__assign({}, args), { completion: code_completions_1.eventStateCompletion, kind: kind, label: "New event state", detail: "Add a new event state" })),
                    createCompletionItem(__assign(__assign({}, args), { completion: code_completions_1.switchStateCompletion, kind: kind, label: "New switch state", detail: "Add a new switch state" })),
                    createCompletionItem(__assign(__assign({}, args), { completion: code_completions_1.injectStateCompletion, kind: kind, label: "New inject state", detail: "Add a new inject state" })),
                ])];
        });
    }); },
    getFunctionCompletions: function (args) { return __awaiter(void 0, void 0, void 0, function () {
        var existingFunctionOperations, specsDir, result, genericFunctionCompletion;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    existingFunctionOperations = swfModelQueries.getFunctions(args.rootNode).map(function (f) { return f.operation; });
                    return [4, args.langServiceConfig.getSpecsDirPosixPaths(args.document)];
                case 1:
                    specsDir = _a.sent();
                    result = args.swfCompletionItemServiceCatalogServices.flatMap(function (swfServiceCatalogService) {
                        return swfServiceCatalogService.functions
                            .filter(function (swfServiceCatalogFunc) { return !existingFunctionOperations.includes(swfServiceCatalogFunc.operation); })
                            .map(function (swfServiceCatalogFunc) {
                            var swfFunction = {
                                name: "${1:".concat(swfServiceCatalogFunc.name, "}"),
                                operation: swfServiceCatalogFunc.operation,
                                type: swfServiceCatalogFunc.type,
                            };
                            var command = {
                                name: "swf.ls.commands.ImportFunctionFromCompletionItem",
                                args: {
                                    containingService: swfServiceCatalogService,
                                    documentUri: args.document.uri,
                                },
                            };
                            var kind = swfServiceCatalogFunc.source.type === api_1.SwfServiceCatalogFunctionSourceType.SERVICE_REGISTRY
                                ? vscode_languageserver_types_1.CompletionItemKind.Interface
                                : vscode_languageserver_types_1.CompletionItemKind.Reference;
                            var label = args.codeCompletionStrategy.formatLabel(toCompletionItemLabelPrefix(swfServiceCatalogFunc, specsDir.specsDirRelativePosixPath), kind);
                            return createCompletionItem(__assign(__assign({}, args), { completion: swfFunction, kind: kind, label: label, detail: swfServiceCatalogService.source.type === api_1.SwfServiceCatalogServiceSourceType.SERVICE_REGISTRY
                                    ? swfServiceCatalogService.source.url
                                    : swfServiceCatalogFunc.operation, extraOptions: {
                                    command: {
                                        command: command.name,
                                        title: "Import function from completion item",
                                        arguments: [command.args],
                                    },
                                } }));
                        });
                    });
                    genericFunctionCompletion = createCompletionItem(__assign(__assign({}, args), { completion: code_completions_1.functionCompletion, kind: vscode_languageserver_types_1.CompletionItemKind.Interface, label: "New function", detail: "Add a new function" }));
                    return [2, Promise.resolve(__spreadArray(__spreadArray([], __read(result), false), [genericFunctionCompletion], false))];
            }
        });
    }); },
    getFunctionOperationCompletions: function (args) {
        var _a, _b, _c;
        if (!((_a = args.currentNode.parent) === null || _a === void 0 ? void 0 : _a.parent)) {
            return Promise.resolve([]);
        }
        var isRestFunction = ((_c = (_b = (0, SwfLanguageService_2.findNodeAtLocation)(args.currentNode.parent.parent, ["type"])) === null || _b === void 0 ? void 0 : _b.value) !== null && _c !== void 0 ? _c : "rest") === "rest";
        if (!isRestFunction) {
            return Promise.resolve([]);
        }
        var existingFunctionOperations = swfModelQueries.getFunctions(args.rootNode).map(function (f) { return f.operation; });
        var result = args.swfCompletionItemServiceCatalogServices
            .flatMap(function (s) { return s.functions; })
            .filter(function (swfServiceCatalogFunc) { return !existingFunctionOperations.includes(swfServiceCatalogFunc.operation); })
            .map(function (swfServiceCatalogFunc) {
            var kind = swfServiceCatalogFunc.source.type === api_1.SwfServiceCatalogFunctionSourceType.SERVICE_REGISTRY
                ? vscode_languageserver_types_1.CompletionItemKind.Function
                : vscode_languageserver_types_1.CompletionItemKind.Folder;
            var label = args.codeCompletionStrategy.formatLabel(swfServiceCatalogFunc.operation, kind);
            return createCompletionItem(__assign(__assign({}, args), { completion: "".concat(swfServiceCatalogFunc.operation), kind: kind, label: label, detail: label }));
        });
        return Promise.resolve(result);
    },
    getFunctionRefCompletions: function (args) {
        if (args.currentNode.type !== "property") {
            console.debug("Cannot autocomplete: functionRef should be a property.");
            return Promise.resolve([]);
        }
        var result = swfModelQueries.getFunctions(args.rootNode).flatMap(function (swfFunction) {
            var swfServiceCatalogFunc = args.swfCompletionItemServiceCatalogServices
                .flatMap(function (f) { return f.functions; })
                .filter(function (f) { return f.operation === swfFunction.operation; })
                .pop();
            if (!swfServiceCatalogFunc) {
                return [];
            }
            var argIndex = 1;
            var swfFunctionRefArgs = {};
            Object.keys(swfServiceCatalogFunc.arguments).forEach(function (argName) {
                swfFunctionRefArgs[argName] = "${".concat(argIndex++, ":}");
            });
            var swfFunctionRef = {
                refName: swfFunction.name,
                arguments: swfFunctionRefArgs,
            };
            var kind = vscode_languageserver_types_1.CompletionItemKind.Module;
            var label = args.codeCompletionStrategy.formatLabel(swfFunctionRef.refName, kind);
            return [
                createCompletionItem(__assign(__assign({}, args), { completion: swfFunctionRef, kind: kind, label: label, detail: "".concat(swfServiceCatalogFunc.operation) })),
            ];
        });
        return Promise.resolve(result);
    },
    getFunctionRefRefnameCompletions: function (args) {
        var result = swfModelQueries.getFunctions(args.rootNode).flatMap(function (swfFunction) {
            var kind = vscode_languageserver_types_1.CompletionItemKind.Value;
            var label = args.codeCompletionStrategy.formatLabel(swfFunction.name, kind);
            return [
                createCompletionItem(__assign(__assign({}, args), { completion: "".concat(swfFunction.name), kind: kind, label: label, detail: "\"".concat(swfFunction.name, "\"") })),
            ];
        });
        return Promise.resolve(result);
    },
    getFunctionRefArgumentsCompletions: function (args) {
        var _a, _b;
        if (args.currentNode.type !== "property" && args.currentNode.type !== "string") {
            console.debug("Cannot autocomplete: arguments should be a property.");
            return Promise.resolve([]);
        }
        var startNode = (0, nodeUpUntilType_1.nodeUpUntilType)(args.currentNode, "object");
        if (!startNode) {
            return Promise.resolve([]);
        }
        var swfFunctionRefName = (_a = (0, SwfLanguageService_2.findNodeAtLocation)(startNode, ["refName"])) === null || _a === void 0 ? void 0 : _a.value;
        if (!swfFunctionRefName) {
            return Promise.resolve([]);
        }
        var swfFunction = (_b = swfModelQueries
            .getFunctions(args.rootNode)) === null || _b === void 0 ? void 0 : _b.filter(function (f) { return f.name === swfFunctionRefName; }).pop();
        if (!swfFunction) {
            return Promise.resolve([]);
        }
        var swfServiceCatalogFunc = args.swfCompletionItemServiceCatalogServices
            .flatMap(function (f) { return f.functions; })
            .filter(function (f) { return f.operation === swfFunction.operation; })
            .pop();
        if (!swfServiceCatalogFunc) {
            return Promise.resolve([]);
        }
        var argIndex = 1;
        var swfFunctionRefArgs = {};
        Object.keys(swfServiceCatalogFunc.arguments).forEach(function (argName) {
            swfFunctionRefArgs[argName] = "${".concat(argIndex++, ":}");
        });
        var kind = vscode_languageserver_types_1.CompletionItemKind.Module;
        var label = "'".concat(swfFunctionRefName, "' arguments");
        return Promise.resolve([
            createCompletionItem(__assign(__assign({}, args), { completion: swfFunctionRefArgs, kind: kind, label: label, detail: swfFunction.operation })),
        ]);
    },
    getEventRefsCompletions: function (args) {
        var result = swfModelQueries.getEvents(args.rootNode).flatMap(function (event) {
            var kind = vscode_languageserver_types_1.CompletionItemKind.Value;
            var label = args.codeCompletionStrategy.formatLabel(event.name, kind);
            return [
                createCompletionItem(__assign(__assign({}, args), { completion: "".concat(event.name), kind: kind, label: label, detail: "\"".concat(event.name, "\"") })),
            ];
        });
        return Promise.resolve(result);
    },
    getTransitionCompletions: function (args) {
        var _a;
        var statePath = (0, SwfLanguageService_1.getNodePath)(args.currentNode).slice(0, 2);
        var currentStateName = ((_a = (0, SwfLanguageService_2.findNodeAtLocation)(args.rootNode, __spreadArray(__spreadArray([], __read(statePath), false), ["name"], false))) === null || _a === void 0 ? void 0 : _a.value) || "";
        var states = swfModelQueries
            .getStates(args.rootNode)
            .filter(function (s) { return s.name !== currentStateName; });
        var result = getStateNameCompletion(__assign(__assign({}, args), { states: states }));
        return Promise.resolve(result);
    },
    getStartCompletions: function (args) {
        var states = swfModelQueries.getStates(args.rootNode);
        var result = getStateNameCompletion(__assign(__assign({}, args), { states: states }));
        return Promise.resolve(result);
    },
};
//# sourceMappingURL=SwfLanguageServiceCodeCompletion.js.map