import { TextDocument } from "vscode-languageserver-textdocument";
import { CodeLens } from "vscode-languageserver-types";
import { SwfLanguageServiceConfig } from "./SwfLanguageService";
import { CodeCompletionStrategy, SwfLsNode } from "./types";
export declare type SwfLanguageServiceCodeLensesFunctionsArgs = {
    config: SwfLanguageServiceConfig;
    document: TextDocument;
    content: string;
    rootNode: SwfLsNode;
    codeCompletionStrategy: CodeCompletionStrategy;
};
export declare const SwfLanguageServiceCodeLenses: {
    createNewSWF: () => CodeLens[];
    addFunction: (args: SwfLanguageServiceCodeLensesFunctionsArgs) => CodeLens[];
    addEvent: (args: SwfLanguageServiceCodeLensesFunctionsArgs) => CodeLens[];
    addState: (args: SwfLanguageServiceCodeLensesFunctionsArgs) => CodeLens[];
    setupServiceRegistries: (args: SwfLanguageServiceCodeLensesFunctionsArgs) => CodeLens[];
    logInServiceRegistries: (args: SwfLanguageServiceCodeLensesFunctionsArgs) => CodeLens[];
    refreshServiceRegistries: (args: SwfLanguageServiceCodeLensesFunctionsArgs) => CodeLens[];
};
//# sourceMappingURL=SwfLanguageServiceCodeLenses.d.ts.map